﻿init python:
    class tictactoe:
        def __init__(self, difficulty):
            self.difficulty = difficulty
            self.board = [
                [0,0,0],
                [0,0,0],
                [0,0,0]
            ]
            self.turn = renpy.random.randint(1,2)
            self.wins = None
        def set(self, row, column):
            if self.board[row][column] == 0 and not self.wins:
                self.board[row][column] = self.turn
                if self.turn == 1:
                    self.turn = 2
                else:
                    self.turn = 1
                self.wins = self.check()
        def reset(self):
            self.board = [
                [0,0,0],
                [0,0,0],
                [0,0,0]
            ]

            self.turn = renpy.random.randint(1,2)
            self.wins = None
        def check(self):
            rows = self.board

            if rows[0] == [1,1,1]:
                return "row 0 1"
            elif rows[0] == [2,2,2]:
                return "row 0 2"
            elif rows[1] == [1,1,1]:
                return "row 1 1"
            elif rows[1] == [2,2,2]:
                return "row 1 2"
            elif rows[2] == [1,1,1]:
                return "row 2 1"
            elif rows[2] == [2,2,2]:
                return "row 2 2"
            
            columns = [[],[],[]]
            for i in self.board:
                columns[0].append(i[0])
                columns[1].append(i[1])
                columns[2].append(i[2])

            if columns[0] == [1,1,1]:
                return "column 0 1"
            elif columns[0] == [2,2,2]:
                return "column 0 2"
            elif columns[1] == [1,1,1]:
                return "column 1 1"
            elif columns[1] == [2,2,2]:
                return "column 1 2"
            elif columns[2] == [1,1,1]:
                return "column 2 1"
            elif columns[2] == [2,2,2]:
                return "column 2 2"

            
            diags = [[self.board[0][0], self.board[1][1], self.board[2][2]], [self.board[0][2], self.board[1][1], self.board[2][0]]]
            if diags[0] == [1,1,1]:
                return "diag 0 1"
            elif diags[0] == [2,2,2]:
                return "diag 0 2"
            elif diags[1] == [1,1,1]:
                return "diag 1 1"
            elif diags[1] == [2,2,2]:
                return "diag 1 2"

            for i in self.board:
                for j in i:
                    if j == 0:
                        return None
            else:
                return "draw"
        def has_empty(self):
            empties = []
            for n,i in enumerate(self.board):
                for m,j in enumerate(i):
                    if j == 0:
                        empties.append([n,m])
            return empties
        def has_win(self):
            for n,i in enumerate(self.board):
                if i in [[0,1,1], [0,2,2]]:
                    return [n,0]
                elif i in [[1,0,1], [2,0,2]]:
                    return [n,1]
                if i in [[1,1,0], [2,2,0]]:
                    return [n,2]

            columns = [[],[],[]]
            for i in self.board:
                columns[0].append(i[0])
                columns[1].append(i[1])
                columns[2].append(i[2])
            for n,i in enumerate(columns):
                if i in [[0,1,1], [0,2,2]]:
                    return [0,n]
                elif i in [[1,0,1], [2,0,2]]:
                    return [1,n]
                if i in [[1,1,0], [2,2,0]]:
                    return [2,n]

            diag1 = [self.board[0][0], self.board[1][1], self.board[2][2]]
            if diag1 in [[0,1,1], [0,2,2]]:
                return [0,0]
            elif diag1 in [[1,0,1], [2,0,2]]:
                return [1,1]
            if diag1 in [[1,1,0], [2,2,0]]:
                return [2,2]

            diag2 = [self.board[0][2], self.board[1][1], self.board[2][0]]
            if diag2 in [[0,1,1], [0,2,2]]:
                return [0,2]
            elif diag2 in [[1,0,1], [2,0,2]]:
                return [1,1]
            if diag2 in [[1,1,0], [2,2,0]]:
                return [2,0]
            return None

        def ai(self):
            if self.turn == 1:
                empties = self.has_empty()
                if len(empties):
                    if self.difficulty == 1:
                        r = renpy.random.choice(empties)
                        self.set(r[0], r[1])
                    elif self.difficulty == 2:
                        r = renpy.random.choice([[0,0], [0,2], [2,0], [2,2]])
                        if r in empties:
                            self.set(r[0], r[1])
                        else:
                            r = renpy.random.choice(empties)
                            self.set(r[0], r[1])
                    elif self.difficulty == 3:
                        wins = self.has_win()
                        if wins:
                            self.set(wins[0], wins[1])
                        else:
                            r = renpy.random.choice([[0,0], [0,2], [2,0], [2,2]])
                            if r in empties:
                                self.set(r[0], r[1])
                            else:
                                r = renpy.random.choice(empties)
                                self.set(r[0], r[1])

screen tic_tac_toe(difficulty = 1):
    default g = tictactoe(difficulty)
    default idx = 0
    # vbox:
    #     text "{}".format(g.wins)
    #     text str(g.turn)
    if g.turn == 1:
        timer 1 repeat True action Function(g.ai)
    fixed:
        align .5,.5
        fit_first True
        add "ttt_grid"
        grid 3 3:
            spacing 0
            for n,j in enumerate(g.board):
                for m,i in enumerate(j):
                    button:
                        xysize 100,100
                        if i == 0:
                            background None
                        elif i == 1:
                            background "ttt_1_{}".format((n+1)*(m+1))
                        elif i == 2:
                            background "ttt_2_{}".format((n+1)*(m+1))
                        action Function(g.set, n, m)
        if g.wins != "draw":
            add g.wins

    add "chalk_1" align .7,.96 at chalk_offset(-bool(g.turn-2)*300, -bool(g.turn-2)*300)
    add "chalk_2" align .3,.96 at chalk_offset(-bool(g.turn-1)*300, -bool(g.turn-1)*300)

    button:
        padding 60,60 offset 80,-5
        align .0,1.0
        text _("Reset")
        action Function(g.reset)
    
    if g.wins == None:
        pass
    elif g.wins == "draw":
        timer 2 action Return("draw")
    elif g.wins.split(" ")[-1] == "1":
        timer 2 action Return("lose")
    elif g.wins.split(" ")[-1] == "2":
        timer 2 action Return("win")

transform chalk_offset(y, r):
    ease .2 yoffset y rotate r
label tic_tac_toe_example:
    show ttt_blackboard with dissolve
    show nana with dissolve
    "So? You've found our secret club."
    "Now You have to prove yourself, in a game of..."
    "Tic Tac Toe!"
    show nana at right with move
    label ttt_nana:
        call screen tic_tac_toe
        if _return == "win":
            "Not bad, not bad at all."
            "Now you have to face a warrior."
        elif _return == "lose":
            "Haha... I'm way better than you."
            "But I'll give you another chance."
            jump ttt_nana
        elif _return == "draw":
            "A draw requires a rematch!"
            jump ttt_nana

    label ttt_hana:
        hide nana with moveoutright
        show hana at right with moveinright
        call screen tic_tac_toe(difficulty = 2)
        if _return == "win":
            "pft, lucky."
            "You'll never be able to beat my Ayame!"
        elif _return == "lose":
            "Wanna go again loser?"
            jump ttt_hana
        elif _return == "draw":
            "Draw!"
            jump ttt_hana

    label ttt_ayame:
        hide hana with moveoutright
        show ayame at right with moveinright
        call screen tic_tac_toe(difficulty = 3)
        if _return == "win":
            "You are very good."
            "Would you join our club?"
        elif _return == "lose":
            "Again?"
            jump ttt_ayame
        elif _return == "draw":
            "Again?"
            jump ttt_ayame





